library IEEE;
use IEEE.std_logic_1164.all;

entity SegmentDecoder is
    port (
        x0: in STD_LOGIC;
        x1: in STD_LOGIC;
        x2: in STD_LOGIC;
        x3: in STD_LOGIC;
        b0: out STD_LOGIC;
        b1: out STD_LOGIC;
        b2: out STD_LOGIC;
        b3: out STD_LOGIC;
        b4: out STD_LOGIC;
        b5: out STD_LOGIC;
        b6: out STD_LOGIC
    );
end SegmentDecoder;

architecture SegmentDecoder_arch of SegmentDecoder is
begin
  -- <<enter your statements here>>
  
   b0 <= ((NOT x3) AND (NOT x2) AND (NOT x1) AND      x0 )   OR
         ((NOT x3) AND      x2  AND (NOT x1) AND (NOT x0))   OR
         (     x3  AND      x2  AND (NOT x1) AND      x0 )   OR
         (     x3  AND (NOT x2) AND      x1  AND      x0 ) ;
         
   b1 <= ((NOT x3) AND      x2  AND (NOT x1) AND      x0 )  OR
         (                  x2  AND      x1  AND (NOT x0))  OR
         (     x3  AND      x2  AND (NOT x1) AND (NOT x0))  OR
         (     x3  AND                   x1  AND      x0 );
         
   b2 <= ((NOT x3) AND (NOT x2) AND      x1  AND (NOT x0))  OR
         (     x3  AND      x2  AND (NOT x1) AND (NOT x0))  OR
         (     x3  AND      x2  AND      x1              );
         
   b3 <= ((NOT x3) AND (NOT x2) AND (NOT x1) AND      x0 )  OR
         ((NOT x3) AND      x2  AND (NOT x1) AND (NOT x0))  OR
         (                  x2  AND      x1  AND      x0 )  OR
         (     x3  AND (NOT x2) AND      x1  AND (NOT x0));
         
   b4 <= ((NOT x3) AND                                x0 )  OR
         ((NOT x3) AND      x2  AND (NOT x1)             )  OR
         (             (NOT x2) AND (NOT x1) AND      x0 );
                      
   b5 <= ((NOT x3) AND (NOT x2) AND                   x0 )  OR
         ((NOT x3) AND                   x1  AND      x0 )  OR
         ((NOT x3) AND (NOT x2) AND      x1              )  OR
         (     x3  AND      x2  AND  NOT x1  AND      x0 );
         
   b6 <= ((NOT x3) AND (NOT x2) AND (NOT x1)             )  OR
         ((NOT x3) AND      x2  AND      x1  AND      x0 )  OR
         (     x3  AND      x2  AND (NOT x1) AND (NOT x0));
   
end SegmentDecoder_arch;
